#ifndef M_STATS_H
#define M_STATS_H
/* Pxys - An IRC ProxyScan, m_stats.h
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: m_stats.h,v 1.4 2001/11/21 15:43:23 mbuna Exp $
 */

#include "config.h"

struct statistics_s {
#ifdef SCAN_WINGATE
   long total_wingate;
#endif
#ifdef SCAN_SOCKS
   long total_socks4;
   long total_socks5;
#endif
#ifdef SCAN_HTTP3128
   long total_http3128;
#endif
#ifdef SCAN_HTTP8080
   long total_http8080;
#endif
#ifdef SCAN_HTTP80
   long total_http80;
#endif
};

typedef struct statistics_s statistics_s;

void stats_init(), stats_free();
void stats_periodical_record(time_t offset);
void stats_dump(const char *nn);
void consolestats();

void human_time(time_t intime, char *outtime);


#endif  /* M_STATS_H */
