#ifndef MS_PARSER_H
#define MS_PARSER_H
/* Pxys - An IRC ProxyScan, ms_parser.h
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ms_parser.h,v 1.4 2001/11/21 15:43:23 mbuna Exp $
 */

#include "tokenizer.h"


#define IsLocalChannel(name)    (*(name) == '&')
#define IsModelessChannel(name) (*(name) == '+')
#define IsChannelName(name)     (*(name) == '#' || \
                                IsModelessChannel(name) || IsLocalChannel(name))
                                
              
void parser_init(), parser_destroy();                  
void irc_parse();

/* Proc Ptr */
typedef void (*irc_cmd_PP)(toktabptr);

#define DECLARE_IRC_CMD(cmd) void parse_##cmd(toktabptr ttab);

DECLARE_IRC_CMD(privmsg)
DECLARE_IRC_CMD(nick)
DECLARE_IRC_CMD(server)
DECLARE_IRC_CMD(quit)
DECLARE_IRC_CMD(squit)
DECLARE_IRC_CMD(kill)
DECLARE_IRC_CMD(ping)
DECLARE_IRC_CMD(rping)
DECLARE_IRC_CMD(mode)
DECLARE_IRC_CMD(eb)
DECLARE_IRC_CMD(ea)
/* DECLARE_IRC_CMD(join) */


#endif  /* MS_PARSER_H */
