/* Pxys - An IRC ProxyScan, numnicks.c
 * IRC - Internet Relay Chat, ircd/channel.c
 * Copyright (C) 1996 Carlo Wood
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: numnicks.c,v 1.2 2001/10/25 01:47:07 mbuna Exp $
 */

#include "config.h"
#include <stdlib.h>
#include <stdio.h>

#include "numnicks.h"

unsigned int
base64toint(const char *s)
{
   unsigned int i = convert2n[(unsigned char) *s++];
   while(*s) {
      i <<= NUMNICKLOG;
      i += convert2n[(unsigned char) *s++];
   }
   return i;
}

const char *
inttobase64(char *buf, unsigned int v, unsigned int count)
{
   buf[count] = '\0';
   while(count > 0) {
      buf[--count] = convert2y[(v & NUMNICKMASK)];
      v >>= NUMNICKLOG;
   }
   return buf;
}


/* warning: not reentrant
char *
dectoip(int myip)
{
   static char buf[16];
   unsigned char *s = (unsigned char *) &myip;
   unsigned char a, b, c, d;
   a = *s++;
   b = *s++;
   c = *s++;
   d = *s++;
   snprintf(buf, sizeof(buf), "%u.%u.%u.%u", d, c, b, a);
   return buf;
}
*/